



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>CF585E. Present for Vitalik the Philatelist [容斥原理 ！]</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">CF585E. Present for Vitalik the Philatelist [容斥原理 ！]</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-15 01:14:16 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3><a href="http://codeforces.com/contest/585/problem/E" rel="external nofollow noreferrer">CF585E. Present for Vitalik the Philatelist</a></h3>
<hr>
<p>题意：\(n \le 5*10^5\) 数列 \(2 \le a_i \le 10^7\)，对于每个数\(a\)满足\(gcd(S)=1,\ gcd(S,a) \neq 1\)的集合称为\(MeowS\)，求\(MeowS\)的个数和</p>
<hr>
<p>一开始想对于每个数求出有多少个数和它互质，就是没有公因子，容斥一下就是:<br /><br />
所有数-1个公质因子+2个不同公质因子-3...<br /><br />
每个数不同的质因子最多有8个，预处理一下貌似可做<br /><br />
</br><br /><br />
然后看到了<a href="http://blog.csdn.net/clove_unique/article/details/64595355" rel="external nofollow noreferrer">zyf2000</a>的神做法，并没有看明白是什么意思，感觉说错了但是做法是对的<br /><br />
</br></p>
<p>然后花了两节课来想为什么，终于想明白了</p>
<p>首先了解一下官方题解的做法：</p>
<ul><li>用容斥求\(gcd\neq 1\)的集合数，就是: $$A = (p_i\mid gcd的子集个数)\ -\ (p_ip_j \mid gcd的子集个数)\ +\ (p_ip_jp_k \mid gcd的子集个数)...$$</li>
<li>然后对于每个数\(a\)在\(A\)中消去包含它的集合的贡献再计入答案，通过枚举它的不同质因子的组合\(p...\)，在上式中消去这个组合的贡献</li></ul>
<p>看起来好复杂...并且枚举还是\(2^8\)</p>
<p>如何简化这个过程？</p>
<p>我们没有必要求每个数，<strong>整体考虑</strong><br /><br />
设质数组合\(p...\)的倍数有\(c\)个，那么它的贡献就是\(2^c-1\)，有多少个数计算的时候没有消去这个贡献呢，\(n-c\)个呀，就是没有这个组合的数！<br /><br />
计算\(A\)的时候直接乘上这个就行了</p>
<p>然后就得到zyf2000的神做法了...</p>
<pre class="prettyprint linenums"><code>#include &lt;iostream&gt;<br />
#include &lt;cstdio&gt;<br />
#include &lt;cstring&gt;<br />
#include &lt;algorithm&gt;<br />
#include &lt;cmath&gt;<br />
using namespace std;<br />
const int N=5e5+5, M=1e7+5, P=1e9+7;<br />
typedef long long ll;<br />
inline ll read(){<br />
	char c=getchar();ll x=0,f=1;<br />
	while(c&lt;'0'||c&gt;'9'){if(c=='-')f=-1;c=getchar();}<br />
	while(c&gt;='0'&amp;&amp;c&lt;='9'){x=x*10+c-'0';c=getchar();}<br />
	return x*f;<br />
}

int n, a, m, mi[N];<br />
int notp[M], p[M], mu[M], c[M];<br />
void sieve(int n) {<br />
	mu[1] = 1;<br />
	for(int i=2; i&lt;=n; i++) {<br />
		if(!notp[i]) p[++p[0]]=i, mu[i]=-1;<br />
		for(int j=1; j&lt;=p[0] &amp;&amp; i*p[j]&lt;=n; j++) {<br />
			notp[i*p[j]] = 1;<br />
			if(i%p[j] == 0) {mu[i*p[j]]=0; break;}<br />
			mu[i*p[j]] = -mu[i];<br />
		}<br />
	}<br />
}

ll ans=0;<br />
int main() {<br />
	//freopen(&quot;in&quot;,&quot;r&quot;,stdin);<br />
	n=read(); mi[0]=1;<br />
	for(int i=1; i&lt;=n; i++) a=read(), m=max(m, a), c[a]++, mi[i]=(mi[i-1]&lt;&lt;1)%P;<br />
	sieve(m);<br />
	for(int i=1; i&lt;=m; i++) {<br />
		int tot=0;<br />
		for(int j=i; j&lt;=m; j+=i) tot += c[j];<br />
		(ans += (ll) (n-tot) * (-mu[i]) * (mi[tot]-1) %P )%=P;<br />
	}<br />
	cout &lt;&lt; (ans+P)%P;<br />
}

</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwedmrq.html">mysql计划任务每天定时执行</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96vpnj8.html">Mybatis 示例之 foreach</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vrmoj8.html">linux中常用目录的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yyvpw8.html">hdu 1429 胜利大逃亡&lpar;延续&rpar;（BFS&plus;比特压缩）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gedn748.html">使用vs2015搭建Asp&period;net Core</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey3vkk9.html">mybatis枚举映射成tinyint</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjx2lx8.html">面试题之小炼牛刀zip&comma;lambda&comma;map</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj0z479.html">使用layer的弹窗时，出现layer引入成功，触发成功，控制台无报错，但是页面无变化或者仅出现遮罩层的问题的解决思路</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllmrr6q.html">工控随笔&lowbar;14&lowbar;西门子&lowbar;Step7项目：打开项目不可用解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlljokeq.html">使用 nodeJs 开发微信公众号（获取access&lowbar;token）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv20xvz9.html">002 Hello Spring Security</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvg1zx8.html">异步核心接口IAsyncResult的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjrm3j9.html">IP路由配置之---------dhcp服务器配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllpwrxq.html">Mouse Detected Problem</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy7zjjq.html">Springboot&plus;Mybatis批量导入多条数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj7lw39.html">scrapy框架学习之路</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2okn2q.html">Jmeter接口测试动态传参&mdash;&mdash;动态获取token值</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv7g6k8.html">dcloud资源升级方式更新app</a>
		</li>
						<li><a href="https://www.batexi.com/a/953g20e8.html">ubuntu for win10 里运行net core</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pk3neq.html">drop user和drop user cascade的区别</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rgmnjr8.html">UVA 1584 字符串</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzge748.html">c&plus;&plus;工程重复编译与重复定义</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgm07d8.html">mysql习题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1n0wyq.html">Unity Object Pool</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pgyl38.html">k8s 创建资源的两种方式 - 每天5分钟玩转 Docker 容器技术（124）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zwkee9.html">PHP面试题：HTTP中POST、GET、PUT、DELETE方式的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1x64gq.html">求助帖：android开发初期：为什么我在活动二设置的singInstance模式跑到活动三去了？？？</a>
			</li>
						<li><a href="https://www.batexi.com/a/90ml45m8.html">【编程技巧】Ext&period;QuickTips&period;init&lpar;&rpar;&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pgz0n8.html">git分支小问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1n721q.html">Python-Blog2-编写Web app 骨架</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
